create or replace package rss_ddl
is

procedure feed;

end;
/

grant execute on rss_ddl to public
/


create or replace package body rss_ddl
is

procedure feed
is
begin
  owa_util.mime_header('text/xml', FALSE); 
  owa_util.http_header_close; 
  htp.p('<?xml version=''1.0'' ?>');
  htp.p('<rss version="2.0">');
  htp.p(' 
	<channel>
<title>Database DDL Events</title>
<description>Overview of the most recent DDL operations in our database</description>
<pubDate>'||to_char(systimestamp)||'</pubDate>
<language>en</language>');
  for o in (select last_ddl_time 
            ,      owner
            ,      object_name
            ,      object_type
            ,      object_id
            from   ( select *                     
                     from   all_objects
                     where  owner <> 'SYS' 
                     and    object_name not like 'BIN%'
                     order
                     by     last_ddl_time desc
                   )
            where rownum < 25
           ) loop
  
  htp.p('<item>
	<title>'||o.object_type||' '||o.object_name||'</title>
<pubDate>'||to_char(o.last_ddl_time,'DAY, MON, DD, YYYY hh24:mi' )||'</pubDate>
<creator>'||o.owner||'</creator>
<category>DDL Modifications</category>
<guid>'||o.object_id||'</guid>
	<description>Modified by user '||o.owner||'
</description>
</item>');
   end loop;
   htp.p('</channel>');
   htp.p('</rss>');

end;

end;
/

